## openvdb 2.1.0

=== Makefile ===
# Copyright (c) 2012-2013 DreamWorks Animation LLC
#
# All rights reserved. This software is distributed under the
# Mozilla Public License 2.0 ( http://www.mozilla.org/MPL/2.0/ )
#
# Redistributions of source code must retain the above copyright
# and license notice and the following restrictions and disclaimer.
#
# *     Neither the name of DreamWorks Animation nor the names of
# its contributors may be used to endorse or promote products derived
# from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
# IN NO EVENT SHALL THE COPYRIGHT HOLDERS' AND CONTRIBUTORS' AGGREGATE
# LIABILITY FOR ALL CLAIMS REGARDLESS OF THEIR BASIS EXCEED US$250.00.
#
# Makefile for the OpenVDB library

# See INSTALL for a list of requirements.
#
# Targets:
#   lib                 the OpenVDB library
#
#   doc                 HTML documentation (doc/html/index.html)
#   pdfdoc              PDF documentation (doc/latex/refman.pdf;
#                       requires LaTeX and ghostscript)
#   python              OpenVDB Python module
#   pytest              unit tests for the Python module
#   pydoc               HTML documentation for the Python module
#                       (doc/html/python/index.html)
#   vdb_print           command-line tool to inspect OpenVDB files
#   vdb_render          command-line tool to ray-trace OpenVDB files
#   vdb_view            command-line tool to view OpenVDB files
#   vdb_test            unit tests for the OpenVDB library
#
#   all                 [default target] all of the above
#   install             install all of the above except vdb_test
#                       into subdirectories of INSTALL_DIR
#   depend              recompute source file header dependencies
#   clean               delete generated files from the local directory
#   test                run tests
#
# Options:
#   shared=no           link executables against static OpenVDB libraries
#                       (default: link against shared libraries)
#   debug=yes           build with debugging symbols and without optimization
#   verbose=yes         run commands (e.g., doxygen) in verbose mode


#
# The following variables must be defined, either here or on the command line
# (e.g., "make install INSTALL_DIR=/usr/local"):
#
# Note that if you plan to build the Houdini OpenVDB tools (distributed
# separately), you must build the OpenVDB library and the Houdini tools
# against compatible versions of the Boost, OpenEXR and TBB libraries.
# Fortunately, all three are included in the Houdini HDK, so the relevant
# variables below point by default to the HDK library and header directories:
# $(HDSO) and $(HT)/include, respectively.  (Source the houdini_setup script
# to set those two environment variables.)
#
# To build the OpenVDB Python module, you will need local distributions of
# Python, Boost.Python, and optionally NumPy.  As of Houdini 12.5, the HDK
# includes versions 2.5 and 2.6 of Python as well as the Boost.Python headers.
# Unfortunately, it does not include the libboost_python library, nor does it
# include NumPy, so both Boost.Python and NumPy have to be built separately.
# Point the variables $(BOOST_PYTHON_LIB_DIR), $(BOOST_PYTHON_LIB) and
# $(NUMPY_INCL_DIR) below to your local distributions of those libraries.
#

# The directory into which to install libraries, executables and header files
INSTALL_DIR := /tmp/OpenVDB

# The parent directory of the boost/ header directory
BOOST_INCL_DIR := $(HT)/include

# The parent directory of the OpenEXR/ header directory
EXR_INCL_DIR := $(HT)/include
# The directory containing libIlmImf, libIlmThread, etc.
EXR_LIB_DIR := $(HDSO)
EXR_LIB := -lIlmImf -lIlmThread -lIex -lImath

# The parent directory of the OpenEXR/ header directory (which contains half.h)
HALF_INCL_DIR := $(EXR_INCL_DIR)
# The directory containing libHalf
HALF_LIB_DIR := $(EXR_LIB_DIR)
HALF_LIB := -lHalf

# The parent directory of the tbb/ header directory
TBB_INCL_DIR := $(HT)/include
# The directory containing libtbb
TBB_LIB_DIR := $(HDSO)
TBB_LIB := -ltbb

# A scalable, concurrent malloc replacement library
# such as jemalloc (included in the Houdini HDK) or TBB malloc
# (leave blank if unavailable)
CONCURRENT_MALLOC_LIB := -ljemalloc
#CONCURRENT_MALLOC_LIB := -ltbbmalloc_proxy -ltbbmalloc
# The directory containing the malloc replacement library
CONCURRENT_MALLOC_LIB_DIR := $(HDSO)

# The parent directory of the cppunit/ header directory
# (leave blank if CppUnit is unavailable)
CPPUNIT_INCL_DIR := /rel/map/generic-2013.22/sys_include
# The directory containing libcppunit
CPPUNIT_LIB_DIR := /rel/depot/third_party_build/cppunit/1.10.2-7/opt-ws5-x86_64-gccWS5_64/lib
CPPUNIT_LIB := -lcppunit

# The directory containing glfw.h
# (leave blank if GLFW is unavailable)
GLFW_INCL_DIR := /rel/third_party/glfw/current/include
# The directory containing libglfw
GLFW_LIB_DIR := /rel/third_party/glfw/current/lib
GLFW_LIB := -lglfw

# The version of Python for which to build the OpenVDB module
# (leave blank if Python is unavailable)
PYTHON_VERSION := 2.6
# The directory containing Python.h
PYTHON_INCL_DIR := $(HFS)/python/include/python$(PYTHON_VERSION)
# The directory containing pyconfig.h
PYCONFIG_INCL_DIR := $(PYTHON_INCL_DIR)
# The directory containing libpython
PYTHON_LIB_DIR := $(HFS)/python/lib
PYTHON_LIB := -lpython$(PYTHON_VERSION)
# The directory containing libboost_python
BOOST_PYTHON_LIB_DIR := /rel/depot/third_party_build/boost/rhel6-1.46.1-0/lib
BOOST_PYTHON_LIB := -lboost_python-gcc41-mt-python26-1_46_1
# The directory containing arrayobject.h
# (leave blank if NumPy is unavailable)
NUMPY_INCL_DIR := /rel/map/generic-2013.22/include
# The Epydoc executable
# (leave blank if Epydoc is unavailable)
EPYDOC := epydoc
# Set PYTHON_WRAP_ALL_GRID_TYPES to "yes" to specify that the Python module
# should expose (almost) all of the grid types defined in openvdb.h
# Otherwise, only FloatGrid, BoolGrid and Vec3SGrid will be exposed
# (see, e.g., exportIntGrid() in python/pyIntGrid.cc).
# Compiling the Python module with PYTHON_WRAP_ALL_GRID_TYPES set to "yes"
# can be very memory-intensive.
PYTHON_WRAP_ALL_GRID_TYPES := no

# The Doxygen executable
# (leave blank if Doxygen is unavailable)
DOXYGEN := doxygen


#
# Ideally, users shouldn't need to change anything below this line.
#

SHELL = /bin/bash

# Turn off implicit rules for speed.
.SUFFIXES:

# Determine the platform.
ifeq ("$(OS)","Windows_NT")
    WINDOWS_NT := 1
else
    UNAME_S := $(shell uname -s)
    ifeq ("$(UNAME_S)","Linux")
        LINUX := 1
    else
        ifeq ("$(UNAME_S)","Darwin")
            MBSD := 1
        endif
    endif
endif

ifeq (yes,$(strip $(debug)))
    OPTIMIZE := -g
else
    OPTIMIZE := -O3 -DNDEBUG
endif

ifeq (yes,$(strip $(verbose)))
    QUIET :=
    QUIET_TEST := -v
else
    QUIET := > /dev/null
    QUIET_TEST := $(QUIET)
endif

has_glfw := no
ifeq (3,$(words $(strip $(GLFW_LIB_DIR) $(GLFW_INCL_DIR) $(GLFW_LIB))))
    has_glfw := yes
endif

has_python := no
ifeq (7,$(words $(strip $(PYTHON_VERSION) $(PYTHON_LIB_DIR) $(PYTHON_INCL_DIR) \
    $(PYCONFIG_INCL_DIR) $(PYTHON_LIB) $(BOOST_PYTHON_LIB_DIR) $(BOOST_PYTHON_LIB))))
    has_python := yes
endif

INCLDIRS := -I . -I .. -I $(BOOST_INCL_DIR) -I $(HALF_INCL_DIR) -I $(TBB_INCL_DIR)

CXXFLAGS += -pthread $(OPTIMIZE) $(INCLDIRS)

LIBS := \
    -ldl -lm -lz \
    -L$(HALF_LIB_DIR) $(HALF_LIB) \
    -L$(TBB_LIB_DIR) $(TBB_LIB) \
#
LIBS_RPATH := \
    -ldl -lm -lz \
    -Wl,-rpath,$(HALF_LIB_DIR) -L$(HALF_LIB_DIR) $(HALF_LIB) \
    -Wl,-rpath,$(TBB_LIB_DIR) -L$(TBB_LIB_DIR) $(TBB_LIB) \
#
ifneq (,$(strip $(CONCURRENT_MALLOC_LIB)))
ifneq (,$(strip $(CONCURRENT_MALLOC_LIB_DIR)))
    LIBS_RPATH += -Wl,-rpath,$(CONCURRENT_MALLOC_LIB_DIR) -L$(CONCURRENT_MALLOC_LIB_DIR)
endif
endif
ifdef LINUX
    LIBS += -lrt
    LIBS_RPATH += -lrt
endif

INCLUDE_NAMES := \
    Exceptions.h \
    Grid.h \
    io/Archive.h \
    io/Compression.h \
    io/File.h \
    io/GridDescriptor.h \
    io/Queue.h \
    io/Stream.h \
    math/BBox.h \
    math/Coord.h \
    math/FiniteDifference.h \
    math/Hermite.h \
    math/LegacyFrustum.h \
    math/Maps.h \
    math/Mat.h \
    math/Mat3.h \
    math/Mat4.h \
    math/Math.h \
    math/Operators.h \
    math/Proximity.h \
    math/QuantizedUnitVec.h \
    math/Quat.h \
    math/Ray.h \
    math/Stats.h \
    math/Stencils.h \
    math/Transform.h\
    math/Tuple.h\
    math/Vec2.h \
    math/Vec3.h \
    math/Vec4.h \
    Metadata.h \
    metadata/Metadata.h \
    metadata/MetaMap.h \
    metadata/StringMetadata.h \
    openvdb.h \
    Platform.h \
    PlatformConfig.h \
    tools/Composite.h \
    tools/Dense.h \
    tools/Filter.h \
    tools/GridOperators.h \
    tools/GridTransformer.h \
    tools/Interpolation.h \
    tools/LevelSetAdvect.h \
    tools/LevelSetFilter.h \
    tools/LevelSetFracture.h \
    tools/LevelSetMeasure.h \
    tools/LevelSetMorph.h \
    tools/LevelSetRebuild.h \
    tools/LevelSetSphere.h \
    tools/LevelSetTracker.h \
    tools/LevelSetUtil.h \
    tools/MeshToVolume.h \
    tools/Morphology.h \
    tools/ParticlesToLevelSet.h \
    tools/PointAdvect.h \
    tools/PointScatter.h \
    tools/RayIntersector.h \
    tools/RayTracer.h \
    tools/Statistics.h \
    tools/ValueTransformer.h \
    tools/VolumeToMesh.h \
    tools/VolumeToSpheres.h \
    tree/InternalNode.h \
    tree/Iterator.h \
    tree/LeafManager.h \
    tree/LeafNode.h \
    tree/LeafNodeBool.h \
    tree/NodeUnion.h \
    tree/RootNode.h \
    tree/Tree.h \
    tree/TreeIterator.h \
    tree/Util.h \
    tree/ValueAccessor.h \
    Types.h \
    util/Formats.h \
    util/logging.h \
    util/MapsUtil.h \
    util/Name.h \
    util/NodeMasks.h \
    util/NullInterrupter.h \
    util/Util.h \
    version.h \
#

SRC_NAMES := \
    Grid.cc \
    io/Archive.cc \
    io/Compression.cc \
    io/File.cc \
    io/GridDescriptor.cc \
    io/Queue.cc \
    io/Stream.cc \
    math/Hermite.cc \
    math/Maps.cc \
    math/Proximity.cc \
    math/QuantizedUnitVec.cc \
    math/Transform.cc \
    metadata/Metadata.cc \
    metadata/MetaMap.cc \
    openvdb.cc \
    Platform.cc \
    util/Formats.cc \
    util/Util.cc \
#

UNITTEST_INCLUDE_NAMES := \
    unittest/util.h \
#

UNITTEST_SRC_NAMES := \
    unittest/main.cc \
    unittest/TestBBox.cc \
    unittest/TestCoord.cc \
    unittest/TestCpt.cc \
    unittest/TestCurl.cc \
    unittest/TestDense.cc \
    unittest/TestDivergence.cc \
    unittest/TestDoubleMetadata.cc \
    unittest/TestExceptions.cc \
    unittest/TestFile.cc \
    unittest/TestFloatMetadata.cc \
    unittest/TestGradient.cc \
    unittest/TestGrid.cc \
    unittest/TestGridBbox.cc \
    unittest/TestGridDescriptor.cc \
    unittest/TestGridIO.cc \
    unittest/TestGridTransformer.cc \
    unittest/TestHermite.cc \
    unittest/TestInit.cc \
    unittest/TestInt32Metadata.cc \
    unittest/TestInt64Metadata.cc \
    unittest/TestInternalOrigin.cc \
    unittest/TestLaplacian.cc \
    unittest/TestLeaf.cc \
    unittest/TestLeafBool.cc \
    unittest/TestLeafIO.cc \
    unittest/TestLeafOrigin.cc \
    unittest/TestLevelSetRayIntersector.cc \
    unittest/TestLevelSetUtil.cc \
    unittest/TestLinearInterp.cc \
    unittest/TestMaps.cc \

=== debian/changelog ===
openvdb (2.1.0-1ubuntu1) trusty; urgency=low

  * debian/rules: update NUMPY_INCL_DIR2 for the correct location

 -- Brian Murray <brian@ubuntu.com>  Thu, 06 Feb 2014 15:20:24 -0800

openvdb (2.1.0-1) unstable; urgency=low

  * New upstream
  * Build on armhf. Closes: #731905
  * Remove patch applied upstream:
    - debian/patches/fix715427.patch
  * Fix compilation with gcc 4.8:
    + debian/patches/fixcomp1.patch

 -- Mathieu Malaterre <malat@debian.org>  Sat, 11 Jan 2014 19:27:54 +0100

openvdb (2.0.0-3) unstable; urgency=low

  * Upload to sid. Closes: #715427
  * Bump Std-Vers to 3.9.5, no changes needed

 -- Mathieu Malaterre <malat@debian.org>  Tue, 10 Dec 2013 09:03:34 +0100

openvdb (2.0.0-2) experimental; urgency=low

  * Fix compilation on 32bits arch
  * Fix compilation on armhf/tbb

 -- Mathieu Malaterre <malat@debian.org>  Mon, 02 Dec 2013 20:47:37 +0100

openvdb (2.0.0-1) experimental; urgency=low

  * New release: 2.0

 -- Mathieu Malaterre <malat@debian.org>  Wed, 27 Nov 2013 11:03:04 +0100

openvdb (1.2.2-1) experimental; urgency=low

  * Take snapshot from upstream

 -- Mathieu Malaterre <malat@debian.org>  Sun, 13 Oct 2013 16:11:51 +0200

openvdb (1.2.0-2) experimental; urgency=low

  * Incorporate changes from new dev tag

 -- Mathieu Malaterre <malat@debian.org>  Thu, 18 Jul 2013 09:26:46 +0200

openvdb (1.2.0-1) unstable; urgency=low

  * New upstream. Fix vdb_view compilation (x86)
  * Refresh patches

 -- Mathieu Malaterre <malat@debian.org>  Thu, 04 Jul 2013 08:27:12 +0200

=== debian/control ===
Source: openvdb
Section: libs
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Mathieu Malaterre <malat@debian.org>
Build-Depends: debhelper (>= 9), libtbb-dev, libopenexr-dev, libz-dev, libboost-dev (>= 1.46), libcppunit-dev, libglfw-dev, libjemalloc-dev, libboost-python-dev, python-numpy
Build-Depends-Indep: doxygen-latex, graphviz, python-epydoc
Homepage: http://openvdb.org
Vcs-Browser: http://anonscm.debian.org/viewvc/collab-maint/deb-maint/openvdb/trunk/
Vcs-Svn: svn://svn.debian.org/collab-maint/deb-maint/openvdb/trunk
Standards-Version: 3.9.5
X-Python-Version: 2.7

Package: libopenvdb2.1
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Sparse Volume Processing toolkit - lib
 OpenVDB is an open source C++ library comprising a novel hierarchical data
 structure and a suite of tools for the efficient storage and manipulation of
 sparse volumetric data discretized on three-dimensional grids. It is developed
 and maintained by DreamWorks Animation for use in volumetric applications
 typically encountered in feature film production.
 .
 This package contains the libraries needed to run OpenVDB applications

Package: libopenvdb-dev
Architecture: any
Section: libdevel
Depends: libopenvdb2.1 (= ${binary:Version}), ${misc:Depends}
Description: Sparse Volume Processing toolkit - dev
 OpenVDB is an open source C++ library comprising a novel hierarchical data
 structure and a suite of tools for the efficient storage and manipulation of
 sparse volumetric data discretized on three-dimensional grids. It is developed
 and maintained by DreamWorks Animation for use in volumetric applications
 typically encountered in feature film production.
 .
 This is the package for developping OpenVDB applications

Package: libopenvdb-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Description: Sparse Volume Processing toolkit - doc
 OpenVDB is an open source C++ library comprising a novel hierarchical data
 structure and a suite of tools for the efficient storage and manipulation of
 sparse volumetric data discretized on three-dimensional grids. It is developed
 and maintained by DreamWorks Animation for use in volumetric applications
 typically encountered in feature film production.
 .
 This is the package for the doc files for OpenVDB

Package: libopenvdb-tools
Architecture: any
Section: utils
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Sparse Volume Processing toolkit - runtime
 OpenVDB is an open source C++ library comprising a novel hierarchical data
 structure and a suite of tools for the efficient storage and manipulation of
 sparse volumetric data discretized on three-dimensional grids. It is developed
 and maintained by DreamWorks Animation for use in volumetric applications
 typically encountered in feature film production.
 .
 This is the package for the runtime. It installs vdb_print and vdb_view

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
VER_FULL = $(shell dpkg-parsechangelog | grep '^Version' | cut -d' ' -f2 | cut -f1 -d-)
VER_FULL = 2.1.0
VER_SONAME = $(shell dpkg-parsechangelog | grep '^Version' | cut -d' ' -f2 | cut -f1 -d- | cut -f1-2 -d.)

#
CFLAGS+=$(CPPFLAGS)
CXXFLAGS+=$(CPPFLAGS)

# tbb issue:
DEB_BUILD_ARCH_CPU := $(shell dpkg-architecture -qDEB_BUILD_ARCH_CPU 2>/dev/null)
ifeq ($(DEB_BUILD_ARCH_CPU), arm)
CXXFLAGS+=-Wa,-mimplicit-it=thumb
endif

# deduce documentation option (build-indep target)
ifeq "" "$(filter %-doc,$(shell dh_listpackages))"
  BUILDDOC = DOXYGEN= EPYDOC=
else
  BUILDDOC =
endif

ALLOPTS = $(BUILDDOC) BOOST_PYTHON_LIB=-lboost_python-py27 PYTHON_VERSION=2.7 PYTHON_INCL_DIR=/usr/include/python2.7 NUMPY_INCL_DIR2=/usr/lib/python2.7/dist-packages/numpy/core/include/numpy/ NUMPY_INCL_DIR=/usr/share/pyshared/numpy/core/include/numpy/ HFS=/removeme HT=/usr HDSO=/usr/lib \
					CPPUNIT_INCL_DIR=/usr/include CPPUNIT_LIB_DIR=/usr/lib \
					GLFW_INCL_DIR=/usr/include/GL GLFW_LIB_DIR=/usr/lib \
					LIBS_RPATH='$(LDFLAGS) -ldl -lm -lz -lHalf -ltbb' LIBOPENVDB_RPATH= \
					verbose=yes debug=yes rpath=no shared=yes

%:
	dh $@ --parallel

MPL: LICENSE
	cp -f $< $@

override_dh_auto_build-arch:
	test -h openvdb||ln -f -s . openvdb
	dh_auto_build -- $(ALLOPTS)

override_dh_auto_test-arch:
	dh_auto_test || true

override_dh_auto_build-indep:
	$(MAKE) doc

# No tests needed for docs
override_dh_auto_test-indep:

# do not run make install
override_dh_auto_install:
	dh_auto_install -- $(ALLOPTS) INSTALL_DIR=$(CURDIR)$(DESTDIR)/debian/tmp/usr INSTALL_LIB_DIR=$(CURDIR)$(DESTDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)
	rm openvdb

pkg_run = libopenvdb-tools
pkg_lib = libopenvdb$(VER_SONAME)
pkg_dev = libopenvdb-dev
pkg_doc = libopenvdb-doc

override_dh_install:
	dh_install -p$(pkg_run) debian/tmp/usr/bin
	dh_install -p$(pkg_lib) debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/libopenvdb.so.$(VER_SONAME)
	dh_install -p$(pkg_lib) debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/libopenvdb.so.$(VER_FULL)
	dh_install -p$(pkg_dev) debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/libopenvdb.so
	dh_install -p$(pkg_dev) debian/tmp/usr/include
	dh_install -p$(pkg_doc) debian/tmp/usr/share/doc

override_dh_installdocs: MPL
	dh_installdocs -A $^

debian/vdb_print.1: debian/vdb_print.1.in
	help2man --version-string=$(VER_FULL) --include=$< --output=$@ --no-info --no-discard-stderr vdb_print

debian/vdb_view.1: debian/vdb_view.1.in
	help2man --version-string=$(VER_FULL) --include=$< --output=$@ --no-info --no-discard-stderr vdb_view

debian/vdb_render.1: debian/vdb_render.1.in
	help2man --version-string=$(VER_FULL) --include=$< --output=$@ --no-info --no-discard-stderr vdb_render

#override_dh_shlibdeps:
#override_dh_installchangelogs:
#	dh_installchangelogs CHANGES
#debian/CHANGES:
#	links -dump http://www.openvdb.org/documentation/doxygen/changes.html | tail -n +7 > $@

get-orig-source:
	uscan --verbose --force-download --rename --repack

=== debian/watch ===
version=3
opts="uversionmangle=s/_/./g" \
http://www.openvdb.org/download/index.html \
./openvdb_([\d_]+)_library\.zip

## openvdb 2.3.0

=== Makefile ===
--- 
+++ 
@@ -116,6 +116,13 @@
 # The directory containing libcppunit
 CPPUNIT_LIB_DIR := /rel/depot/third_party_build/cppunit/1.10.2-7/opt-ws5-x86_64-gccWS5_64/lib
 CPPUNIT_LIB := -lcppunit
+
+# The parent directory of the log4cplus/ header directory
+# (leave blank if log4cplus is unavailable)
+LOG4CPLUS_INCL_DIR := /rel/folio/log4cplus/log4cplus-1.0.3-latest/sys_include
+# The directory containing liblog4cplus
+LOG4CPLUS_LIB_DIR := /rel/folio/log4cplus/log4cplus-1.0.3-latest/library
+LOG4CPLUS_LIB := -llog4cplus
 
 # The directory containing glfw.h
 # (leave blank if GLFW is unavailable)
@@ -198,6 +205,11 @@
     has_glfw := yes
 endif
 
+has_log4cplus := no
+ifeq (3,$(words $(strip $(LOG4CPLUS_LIB_DIR) $(LOG4CPLUS_INCL_DIR) $(LOG4CPLUS_LIB))))
+    has_log4cplus := yes
+endif
+
 has_python := no
 ifeq (7,$(words $(strip $(PYTHON_VERSION) $(PYTHON_LIB_DIR) $(PYTHON_INCL_DIR) \
     $(PYCONFIG_INCL_DIR) $(PYTHON_LIB) $(BOOST_PYTHON_LIB_DIR) $(BOOST_PYTHON_LIB))))
@@ -205,8 +217,14 @@
 endif
 
 INCLDIRS := -I . -I .. -I $(BOOST_INCL_DIR) -I $(HALF_INCL_DIR) -I $(TBB_INCL_DIR)
+ifeq (yes,$(has_log4cplus))
+	INCLDIRS += -I $(LOG4CPLUS_INCL_DIR)
+endif
 
 CXXFLAGS += -pthread $(OPTIMIZE) $(INCLDIRS)
+ifeq (yes,$(has_log4cplus))
+	CXXFLAGS += -DOPENVDB_USE_LOG4CPLUS
+endif
 
 LIBS := \
     -ldl -lm -lz \
@@ -218,6 +236,10 @@
     -Wl,-rpath,$(HALF_LIB_DIR) -L$(HALF_LIB_DIR) $(HALF_LIB) \
     -Wl,-rpath,$(TBB_LIB_DIR) -L$(TBB_LIB_DIR) $(TBB_LIB) \
 #
+ifeq (yes,$(has_log4cplus))
+    LIBS += -L$(LOG4CPLUS_LIB_DIR) $(LOG4CPLUS_LIB)
+    LIBS_RPATH += -Wl,-rpath,$(LOG4CPLUS_LIB_DIR) -L$(LOG4CPLUS_LIB_DIR) $(LOG4CPLUS_LIB)
+endif
 ifneq (,$(strip $(CONCURRENT_MALLOC_LIB)))
 ifneq (,$(strip $(CONCURRENT_MALLOC_LIB_DIR)))
     LIBS_RPATH += -Wl,-rpath,$(CONCURRENT_MALLOC_LIB_DIR) -L$(CONCURRENT_MALLOC_LIB_DIR)
@@ -239,6 +261,7 @@
     io/Stream.h \
     math/BBox.h \
     math/Coord.h \
+    math/DDA.h \
     math/FiniteDifference.h \
     math/Hermite.h \
     math/LegacyFrustum.h \
@@ -268,6 +291,7 @@
     PlatformConfig.h \
     tools/Composite.h \
     tools/Dense.h \
+    tools/DenseSparseTools.h \
     tools/Filter.h \
     tools/GridOperators.h \
     tools/GridTransformer.h \
@@ -290,6 +314,7 @@
     tools/RayTracer.h \
     tools/Statistics.h \
     tools/ValueTransformer.h \
+    tools/VectorTransformer.h \
     tools/VolumeToMesh.h \
     tools/VolumeToSpheres.h \
     tree/InternalNode.h \
@@ -345,29 +370,3 @@
     unittest/TestCoord.cc \
     unittest/TestCpt.cc \
     unittest/TestCurl.cc \
-    unittest/TestDense.cc \
-    unittest/TestDivergence.cc \
-    unittest/TestDoubleMetadata.cc \
-    unittest/TestExceptions.cc \
-    unittest/TestFile.cc \
-    unittest/TestFloatMetadata.cc \
-    unittest/TestGradient.cc \
-    unittest/TestGrid.cc \
-    unittest/TestGridBbox.cc \
-    unittest/TestGridDescriptor.cc \
-    unittest/TestGridIO.cc \
-    unittest/TestGridTransformer.cc \
-    unittest/TestHermite.cc \
-    unittest/TestInit.cc \
-    unittest/TestInt32Metadata.cc \
-    unittest/TestInt64Metadata.cc \
-    unittest/TestInternalOrigin.cc \
-    unittest/TestLaplacian.cc \
-    unittest/TestLeaf.cc \
-    unittest/TestLeafBool.cc \
-    unittest/TestLeafIO.cc \
-    unittest/TestLeafOrigin.cc \
-    unittest/TestLevelSetRayIntersector.cc \
-    unittest/TestLevelSetUtil.cc \
-    unittest/TestLinearInterp.cc \
-    unittest/TestMaps.cc \

=== debian/changelog ===
openvdb (2.3.0-2) unstable; urgency=low

  * Add python binding. Closes: #751763

 -- Mathieu Malaterre <malat@debian.org>  Fri, 04 Jul 2014 10:37:00 +0200

openvdb (2.3.0-1) unstable; urgency=low

  * New release
  * Build with log4cplus

 -- Mathieu Malaterre <malat@debian.org>  Wed, 04 Jun 2014 14:24:29 +0200

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,19 @@
 Source: openvdb
 Section: libs
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Mathieu Malaterre <malat@debian.org>
-Build-Depends: debhelper (>= 9), libtbb-dev, libopenexr-dev, libz-dev, libboost-dev (>= 1.46), libcppunit-dev, libglfw-dev, libjemalloc-dev, libboost-python-dev, python-numpy
+Maintainer: Mathieu Malaterre <malat@debian.org>
+Build-Depends: debhelper (>= 9),
+               libboost-dev (>= 1.46),
+               libboost-python-dev,
+               libcppunit-dev,
+               libglfw-dev,
+               libjemalloc-dev,
+               liblog4cplus-dev,
+               libopenexr-dev,
+               libtbb-dev,
+               libz-dev,
+               python-all-dev,
+               python-numpy
 Build-Depends-Indep: doxygen-latex, graphviz, python-epydoc
 Homepage: http://openvdb.org
 Vcs-Browser: http://anonscm.debian.org/viewvc/collab-maint/deb-maint/openvdb/trunk/
@@ -11,9 +21,9 @@
 Standards-Version: 3.9.5
 X-Python-Version: 2.7
 
-Package: libopenvdb2.1
+Package: libopenvdb2.3
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}
+Depends: ${misc:Depends}, ${shlibs:Depends}
 Pre-Depends: ${misc:Pre-Depends}
 Description: Sparse Volume Processing toolkit - lib
  OpenVDB is an open source C++ library comprising a novel hierarchical data
@@ -27,7 +37,7 @@
 Package: libopenvdb-dev
 Architecture: any
 Section: libdevel
-Depends: libopenvdb2.1 (= ${binary:Version}), ${misc:Depends}
+Depends: libopenvdb2.3 (= ${binary:Version}), ${misc:Depends}
 Description: Sparse Volume Processing toolkit - dev
  OpenVDB is an open source C++ library comprising a novel hierarchical data
  structure and a suite of tools for the efficient storage and manipulation of
@@ -53,7 +63,7 @@
 Package: libopenvdb-tools
 Architecture: any
 Section: utils
-Depends: ${shlibs:Depends}, ${misc:Depends}
+Depends: ${misc:Depends}, ${shlibs:Depends}
 Description: Sparse Volume Processing toolkit - runtime
  OpenVDB is an open source C++ library comprising a novel hierarchical data
  structure and a suite of tools for the efficient storage and manipulation of
@@ -61,4 +71,19 @@
  and maintained by DreamWorks Animation for use in volumetric applications
  typically encountered in feature film production.
  .
- This is the package for the runtime. It installs vdb_print and vdb_view
+ This is the package for the runtime. It installs vdb_print, vdb_render and
+ vdb_view
+
+Package: python-openvdb
+Architecture: any
+Section: python
+Depends: ${misc:Depends}, ${python:Depends}, ${shlibs:Depends}
+Provides: ${python:Provides}
+Description: Sparse Volume Processing toolkit - python binding
+ OpenVDB is an open source C++ library comprising a novel hierarchical data
+ structure and a suite of tools for the efficient storage and manipulation of
+ sparse volumetric data discretized on three-dimensional grids. It is developed
+ and maintained by DreamWorks Animation for use in volumetric applications
+ typically encountered in feature film production.
+ .
+ This is the package for the Python binding.

=== debian/rules ===
--- 
+++ 
@@ -3,7 +3,7 @@
 
 DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
 VER_FULL = $(shell dpkg-parsechangelog | grep '^Version' | cut -d' ' -f2 | cut -f1 -d-)
-VER_FULL = 2.1.0
+VER_FULL = 2.3.0
 VER_SONAME = $(shell dpkg-parsechangelog | grep '^Version' | cut -d' ' -f2 | cut -f1 -d- | cut -f1-2 -d.)
 
 #
@@ -23,20 +23,25 @@
   BUILDDOC =
 endif
 
-ALLOPTS = $(BUILDDOC) BOOST_PYTHON_LIB=-lboost_python-py27 PYTHON_VERSION=2.7 PYTHON_INCL_DIR=/usr/include/python2.7 NUMPY_INCL_DIR2=/usr/lib/python2.7/dist-packages/numpy/core/include/numpy/ NUMPY_INCL_DIR=/usr/share/pyshared/numpy/core/include/numpy/ HFS=/removeme HT=/usr HDSO=/usr/lib \
+ALLOPTS = $(BUILDDOC) BOOST_PYTHON_LIB=-lboost_python-py27 PYTHON_VERSION=2.7 \
+					PYTHON_INCL_DIR=/usr/include/python2.7 NUMPY_INCL_DIR2=/usr/lib/python2.7/dist-packages/numpy/core/include/numpy/ \
+					NUMPY_INCL_DIR=/usr/share/pyshared/numpy/core/include/numpy/ HFS=/removeme HT=/usr HDSO=/usr/lib \
+					EXR_INCL_DIR=/usr/include/OpenEXR \
 					CPPUNIT_INCL_DIR=/usr/include CPPUNIT_LIB_DIR=/usr/lib \
+					LOG4CPLUS_INCL_DIR=/usr/include LOG4CPLUS_LIB_DIR=/usr/lib \
 					GLFW_INCL_DIR=/usr/include/GL GLFW_LIB_DIR=/usr/lib \
-					LIBS_RPATH='$(LDFLAGS) -ldl -lm -lz -lHalf -ltbb' LIBOPENVDB_RPATH= \
+					LIBS_RPATH='$(LDFLAGS) -ldl -lm -lz -lHalf -ltbb -llog4cplus' LIBOPENVDB_RPATH= \
+					PYTHON_SONAME_FLAGS= BOOST_PYTHON_LIB=-lboost_python-py27 \
 					verbose=yes debug=yes rpath=no shared=yes
 
 %:
-	dh $@ --parallel
+	dh $@ --parallel --with python2
 
 MPL: LICENSE
 	cp -f $< $@
 
 override_dh_auto_build-arch:
-	test -h openvdb||ln -f -s . openvdb
+	test -h openvdb || ln -f -s . openvdb
 	dh_auto_build -- $(ALLOPTS)
 
 override_dh_auto_test-arch:
@@ -57,6 +62,9 @@
 pkg_lib = libopenvdb$(VER_SONAME)
 pkg_dev = libopenvdb-dev
 pkg_doc = libopenvdb-doc
+pkg_py  = python-openvdb
+
+PYMODDIR := /usr/lib/$(shell pyversions -r)
 
 override_dh_install:
 	dh_install -p$(pkg_run) debian/tmp/usr/bin
@@ -65,10 +73,12 @@
 	dh_install -p$(pkg_dev) debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/libopenvdb.so
 	dh_install -p$(pkg_dev) debian/tmp/usr/include
 	dh_install -p$(pkg_doc) debian/tmp/usr/share/doc
+	dh_install -p$(pkg_py)  debian/tmp/usr/python/lib/python2.7/pyopenvdb.so $(PYMODDIR)/dist-packages/
 
 override_dh_installdocs: MPL
 	dh_installdocs -A $^
 
+# man page cannot be automatically generated since we need to cleanup help2man output
 debian/vdb_print.1: debian/vdb_print.1.in
 	help2man --version-string=$(VER_FULL) --include=$< --output=$@ --no-info --no-discard-stderr vdb_print
 
@@ -78,11 +88,5 @@
 debian/vdb_render.1: debian/vdb_render.1.in
 	help2man --version-string=$(VER_FULL) --include=$< --output=$@ --no-info --no-discard-stderr vdb_render
 
-#override_dh_shlibdeps:
-#override_dh_installchangelogs:
-#	dh_installchangelogs CHANGES
-#debian/CHANGES:
-#	links -dump http://www.openvdb.org/documentation/doxygen/changes.html | tail -n +7 > $@
-
 get-orig-source:
 	uscan --verbose --force-download --rename --repack

## openvdb 3.0.0

=== debian/changelog ===
openvdb (3.0.0-3ubuntu4) wily; urgency=medium

  * Include -latomic in the linker line to deal with the new libtbb.
  * Update the symbols file for all architectures including powerpc.

 -- Adam Conrad <adconrad@ubuntu.com>  Tue, 11 Aug 2015 23:17:50 -0600

openvdb (3.0.0-3ubuntu3) wily; urgency=medium

  * Update the symbols file for all architectures.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 11 Aug 2015 12:16:04 +0000

openvdb (3.0.0-3ubuntu2) wily; urgency=medium

  * Update the symbols file for all architectures.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 07 Aug 2015 15:26:15 +0200

openvdb (3.0.0-3ubuntu1) wily; urgency=medium

  * Regenerate the symbols file for the new libstdc++ ABI.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 07 Aug 2015 14:03:59 +0200

openvdb (3.0.0-3build1) wily; urgency=medium

  * No-change rebuild against libopenexr22.

 -- Martin Pitt <martin.pitt@ubuntu.com>  Thu, 06 Aug 2015 12:27:15 +0200

openvdb (3.0.0-3) unstable; urgency=medium

  * Fix symbols file on armhf/i386/ppc64

 -- Mathieu Malaterre <malat@debian.org>  Wed, 10 Jun 2015 14:36:57 +0200

openvdb (3.0.0-2) unstable; urgency=medium

  * Fix symbols file manually.
  * Fix debian/rules clean target (doxygen left a *.db file)

 -- Mathieu Malaterre <malat@debian.org>  Thu, 28 May 2015 15:29:20 +0200

openvdb (3.0.0-1) unstable; urgency=medium

  * New upstream: 3.0
  * Add a timeout for arm64. Closes: #770487
  * Add symbols files

 -- Mathieu Malaterre <malat@debian.org>  Tue, 26 May 2015 17:07:31 +0200

=== debian/control ===
--- 
+++ 
@@ -1,12 +1,19 @@
 Source: openvdb
 Section: libs
 Priority: optional
-Maintainer: Mathieu Malaterre <malat@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Mathieu Malaterre <malat@debian.org>
 Build-Depends: debhelper (>= 9),
+               dh-python,
+               dpkg-dev (>= 1.18.0),
                libboost-dev (>= 1.46),
+               libboost-filesystem-dev,
+               libboost-iostreams-dev,
                libboost-python-dev,
+               libboost-system-dev,
+               libboost-thread-dev,
                libcppunit-dev,
-               libglfw-dev,
+               libglfw3-dev,
                libjemalloc-dev,
                liblog4cplus-dev,
                libopenexr-dev,
@@ -18,10 +25,10 @@
 Homepage: http://openvdb.org
 Vcs-Browser: http://anonscm.debian.org/viewvc/collab-maint/deb-maint/openvdb/trunk/
 Vcs-Svn: svn://svn.debian.org/collab-maint/deb-maint/openvdb/trunk
-Standards-Version: 3.9.5
+Standards-Version: 3.9.6
 X-Python-Version: 2.7
 
-Package: libopenvdb2.3
+Package: libopenvdb3.0
 Architecture: any
 Depends: ${misc:Depends}, ${shlibs:Depends}
 Pre-Depends: ${misc:Pre-Depends}
@@ -37,7 +44,7 @@
 Package: libopenvdb-dev
 Architecture: any
 Section: libdevel
-Depends: libopenvdb2.3 (= ${binary:Version}), ${misc:Depends}
+Depends: libopenvdb3.0 (= ${binary:Version}), ${misc:Depends}
 Description: Sparse Volume Processing toolkit - dev
  OpenVDB is an open source C++ library comprising a novel hierarchical data
  structure and a suite of tools for the efficient storage and manipulation of
@@ -79,7 +86,7 @@
 Section: python
 Depends: ${misc:Depends}, ${python:Depends}, ${shlibs:Depends}
 Provides: ${python:Provides}
-Description: Sparse Volume Processing toolkit - python binding
+Description: Sparse Volume Processing toolkit - Python binding
  OpenVDB is an open source C++ library comprising a novel hierarchical data
  structure and a suite of tools for the efficient storage and manipulation of
  sparse volumetric data discretized on three-dimensional grids. It is developed

=== debian/rules ===
--- 
+++ 
@@ -1,14 +1,18 @@
 #!/usr/bin/make -f
 #export DH_VERBOSE=1
 
+export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
+
+# as per upstream request:
+#export DEB_CFLAGS_MAINT_APPEND = -fvisibility=hidden
+
 DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
 VER_FULL = $(shell dpkg-parsechangelog | grep '^Version' | cut -d' ' -f2 | cut -f1 -d-)
-VER_FULL = 2.3.0
 VER_SONAME = $(shell dpkg-parsechangelog | grep '^Version' | cut -d' ' -f2 | cut -f1 -d- | cut -f1-2 -d.)
 
 #
-CFLAGS+=$(CPPFLAGS)
-CXXFLAGS+=$(CPPFLAGS)
+CFLAGS+=$(CPPFLAGS) -fvisibility=hidden
+CXXFLAGS+=$(CPPFLAGS) -fvisibility=hidden
 
 # tbb issue:
 DEB_BUILD_ARCH_CPU := $(shell dpkg-architecture -qDEB_BUILD_ARCH_CPU 2>/dev/null)
@@ -30,8 +34,9 @@
 					CPPUNIT_INCL_DIR=/usr/include CPPUNIT_LIB_DIR=/usr/lib \
 					LOG4CPLUS_INCL_DIR=/usr/include LOG4CPLUS_LIB_DIR=/usr/lib \
 					GLFW_INCL_DIR=/usr/include/GL GLFW_LIB_DIR=/usr/lib \
-					LIBS_RPATH='$(LDFLAGS) -ldl -lm -lz -lHalf -ltbb -llog4cplus' LIBOPENVDB_RPATH= \
+					LIBS_RPATH='$(LDFLAGS) -ldl -lm -lz -lHalf -ltbb -latomic -llog4cplus -lboost_filesystem -lboost_system -lboost_iostreams' LIBOPENVDB_RPATH= \
 					PYTHON_SONAME_FLAGS= BOOST_PYTHON_LIB=-lboost_python-py27 \
+					BLOSC_INCL_DIR= BLOSC_LIB_DIR= BLOSC_LIB= \
 					verbose=yes debug=yes rpath=no shared=yes
 
 %:
@@ -45,7 +50,7 @@
 	dh_auto_build -- $(ALLOPTS)
 
 override_dh_auto_test-arch:
-	dh_auto_test || true
+	timeout 2h dh_auto_test || true
 
 override_dh_auto_build-indep:
 	$(MAKE) doc
@@ -55,7 +60,7 @@
 
 # do not run make install
 override_dh_auto_install:
-	dh_auto_install -- $(ALLOPTS) INSTALL_DIR=$(CURDIR)$(DESTDIR)/debian/tmp/usr INSTALL_LIB_DIR=$(CURDIR)$(DESTDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)
+	dh_auto_install -- $(ALLOPTS) DESTDIR=$(CURDIR)$(DESTDIR)/debian/tmp/usr DESTDIR_LIB_DIR=$(CURDIR)$(DESTDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)
 	rm openvdb
 
 pkg_run = libopenvdb-tools
@@ -67,16 +72,23 @@
 PYMODDIR := /usr/lib/$(shell pyversions -r)
 
 override_dh_install:
+	dh_numpy --package=$(pkg_py)
 	dh_install -p$(pkg_run) debian/tmp/usr/bin
 	dh_install -p$(pkg_lib) debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/libopenvdb.so.$(VER_SONAME)
 	dh_install -p$(pkg_lib) debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/libopenvdb.so.$(VER_FULL)
 	dh_install -p$(pkg_dev) debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/libopenvdb.so
 	dh_install -p$(pkg_dev) debian/tmp/usr/include
-	dh_install -p$(pkg_doc) debian/tmp/usr/share/doc
+	#dh_install -p$(pkg_doc) debian/tmp/usr/share/doc
 	dh_install -p$(pkg_py)  debian/tmp/usr/python/lib/python2.7/pyopenvdb.so $(PYMODDIR)/dist-packages/
 
 override_dh_installdocs: MPL
 	dh_installdocs -A $^
+
+#override_dh_shlibdeps:
+#	dh_shlibdeps --dpkg-shlibdeps-params=--ignore-missing-info
+
+override_dh_clean:
+	dh_clean doc/doxygen_sqlite3.db
 
 # man page cannot be automatically generated since we need to cleanup help2man output
 debian/vdb_print.1: debian/vdb_print.1.in
